describe("services.transformer.ApiResponse", function () {
    var transformer, response;

    beforeEach(function () {
        module('publicapi.transformers');
        inject(function ($injector) {
            transformer = $injector.get('services.transformer.ApiResponse');
        });
    });

    it("Should return an empty array when it receives an empty array", function () {
        expect(transformer('[]')).toEqual([]);
    });

    it("Should parse the response to 3 items with userName and gitUrl defined", function () {
        expect(transformer(response)).toEqual(
            [
                {userName: "mralexgray/-REPONAME", gitUrl: "git://github.com/mralexgray/-REPONAME.git"},
                {userName: "mralexgray/ace", gitUrl: "git://github.com/mralexgray/ace.git"},
                {userName: "mralexgray/ACEView", gitUrl: "git://github.com/mralexgray/ACEView.git"}
            ]
        );
    });

    //Response Fixture
    beforeEach(function () {
//        [
//            {userName: "mralexgray/-REPONAME", gitUrl: "git://github.com/mralexgray/-REPONAME.git"},
//            {userName: "mralexgray/ace", gitUrl: "git://github.com/mralexgray/ace.git"},
//            {userName: "mralexgray/ACEView", gitUrl: "git://github.com/mralexgray/ACEView.git"}
//        ]
        response = JSON.stringify(
            [
                {
                    "id": 6104546,
                    "name": "-REPONAME",
                    "full_name": "mralexgray/-REPONAME",
                    "owner": {
                        "login": "mralexgray",
                        "id": 262517,
                        "avatar_url": "https://gravatar.com/avatar/50e7ed4eb2e7af000ea7d161748958f1?d=https%3A%2F%2Fidenticons.github.com%2F27bbb5393e06a225e4ecf9c4ce6feabf.png&r=x",
                        "gravatar_id": "50e7ed4eb2e7af000ea7d161748958f1",
                        "url": "https://api.github.com/users/mralexgray",
                        "html_url": "https://github.com/mralexgray",
                        "followers_url": "https://api.github.com/users/mralexgray/followers",
                        "following_url": "https://api.github.com/users/mralexgray/following{/other_user}",
                        "gists_url": "https://api.github.com/users/mralexgray/gists{/gist_id}",
                        "starred_url": "https://api.github.com/users/mralexgray/starred{/owner}{/repo}",
                        "subscriptions_url": "https://api.github.com/users/mralexgray/subscriptions",
                        "organizations_url": "https://api.github.com/users/mralexgray/orgs",
                        "repos_url": "https://api.github.com/users/mralexgray/repos",
                        "events_url": "https://api.github.com/users/mralexgray/events{/privacy}",
                        "received_events_url": "https://api.github.com/users/mralexgray/received_events",
                        "type": "User",
                        "site_admin": false
                    },
                    "private": false,
                    "html_url": "https://github.com/mralexgray/-REPONAME",
                    "description": null,
                    "fork": false,
                    "url": "https://api.github.com/repos/mralexgray/-REPONAME",
                    "forks_url": "https://api.github.com/repos/mralexgray/-REPONAME/forks",
                    "keys_url": "https://api.github.com/repos/mralexgray/-REPONAME/keys{/key_id}",
                    "collaborators_url": "https://api.github.com/repos/mralexgray/-REPONAME/collaborators{/collaborator}",
                    "teams_url": "https://api.github.com/repos/mralexgray/-REPONAME/teams",
                    "hooks_url": "https://api.github.com/repos/mralexgray/-REPONAME/hooks",
                    "issue_events_url": "https://api.github.com/repos/mralexgray/-REPONAME/issues/events{/number}",
                    "events_url": "https://api.github.com/repos/mralexgray/-REPONAME/events",
                    "assignees_url": "https://api.github.com/repos/mralexgray/-REPONAME/assignees{/user}",
                    "branches_url": "https://api.github.com/repos/mralexgray/-REPONAME/branches{/branch}",
                    "tags_url": "https://api.github.com/repos/mralexgray/-REPONAME/tags",
                    "blobs_url": "https://api.github.com/repos/mralexgray/-REPONAME/git/blobs{/sha}",
                    "git_tags_url": "https://api.github.com/repos/mralexgray/-REPONAME/git/tags{/sha}",
                    "git_refs_url": "https://api.github.com/repos/mralexgray/-REPONAME/git/refs{/sha}",
                    "trees_url": "https://api.github.com/repos/mralexgray/-REPONAME/git/trees{/sha}",
                    "statuses_url": "https://api.github.com/repos/mralexgray/-REPONAME/statuses/{sha}",
                    "languages_url": "https://api.github.com/repos/mralexgray/-REPONAME/languages",
                    "stargazers_url": "https://api.github.com/repos/mralexgray/-REPONAME/stargazers",
                    "contributors_url": "https://api.github.com/repos/mralexgray/-REPONAME/contributors",
                    "subscribers_url": "https://api.github.com/repos/mralexgray/-REPONAME/subscribers",
                    "subscription_url": "https://api.github.com/repos/mralexgray/-REPONAME/subscription",
                    "commits_url": "https://api.github.com/repos/mralexgray/-REPONAME/commits{/sha}",
                    "git_commits_url": "https://api.github.com/repos/mralexgray/-REPONAME/git/commits{/sha}",
                    "comments_url": "https://api.github.com/repos/mralexgray/-REPONAME/comments{/number}",
                    "issue_comment_url": "https://api.github.com/repos/mralexgray/-REPONAME/issues/comments/{number}",
                    "contents_url": "https://api.github.com/repos/mralexgray/-REPONAME/contents/{+path}",
                    "compare_url": "https://api.github.com/repos/mralexgray/-REPONAME/compare/{base}...{head}",
                    "merges_url": "https://api.github.com/repos/mralexgray/-REPONAME/merges",
                    "archive_url": "https://api.github.com/repos/mralexgray/-REPONAME/{archive_format}{/ref}",
                    "downloads_url": "https://api.github.com/repos/mralexgray/-REPONAME/downloads",
                    "issues_url": "https://api.github.com/repos/mralexgray/-REPONAME/issues{/number}",
                    "pulls_url": "https://api.github.com/repos/mralexgray/-REPONAME/pulls{/number}",
                    "milestones_url": "https://api.github.com/repos/mralexgray/-REPONAME/milestones{/number}",
                    "notifications_url": "https://api.github.com/repos/mralexgray/-REPONAME/notifications{?since,all,participating}",
                    "labels_url": "https://api.github.com/repos/mralexgray/-REPONAME/labels{/name}",
                    "releases_url": "https://api.github.com/repos/mralexgray/-REPONAME/releases{/id}",
                    "created_at": "2012-10-06T16:37:39Z",
                    "updated_at": "2013-01-12T13:39:30Z",
                    "pushed_at": "2012-10-06T16:37:39Z",
                    "git_url": "git://github.com/mralexgray/-REPONAME.git",
                    "ssh_url": "git@github.com:mralexgray/-REPONAME.git",
                    "clone_url": "https://github.com/mralexgray/-REPONAME.git",
                    "svn_url": "https://github.com/mralexgray/-REPONAME",
                    "homepage": null,
                    "size": 76,
                    "stargazers_count": 0,
                    "watchers_count": 0,
                    "language": null,
                    "has_issues": true,
                    "has_downloads": true,
                    "has_wiki": true,
                    "forks_count": 0,
                    "mirror_url": null,
                    "open_issues_count": 0,
                    "forks": 0,
                    "open_issues": 0,
                    "watchers": 0
                },
                {
                    "id": 13121042,
                    "name": "ace",
                    "full_name": "mralexgray/ace",
                    "owner": {
                        "login": "mralexgray",
                        "id": 262517,
                        "avatar_url": "https://gravatar.com/avatar/50e7ed4eb2e7af000ea7d161748958f1?d=https%3A%2F%2Fidenticons.github.com%2F27bbb5393e06a225e4ecf9c4ce6feabf.png&r=x",
                        "gravatar_id": "50e7ed4eb2e7af000ea7d161748958f1",
                        "url": "https://api.github.com/users/mralexgray",
                        "html_url": "https://github.com/mralexgray",
                        "followers_url": "https://api.github.com/users/mralexgray/followers",
                        "following_url": "https://api.github.com/users/mralexgray/following{/other_user}",
                        "gists_url": "https://api.github.com/users/mralexgray/gists{/gist_id}",
                        "starred_url": "https://api.github.com/users/mralexgray/starred{/owner}{/repo}",
                        "subscriptions_url": "https://api.github.com/users/mralexgray/subscriptions",
                        "organizations_url": "https://api.github.com/users/mralexgray/orgs",
                        "repos_url": "https://api.github.com/users/mralexgray/repos",
                        "events_url": "https://api.github.com/users/mralexgray/events{/privacy}",
                        "received_events_url": "https://api.github.com/users/mralexgray/received_events",
                        "type": "User",
                        "site_admin": false
                    },
                    "private": false,
                    "html_url": "https://github.com/mralexgray/ace",
                    "description": "Ace (Ajax.org Cloud9 Editor)",
                    "fork": true,
                    "url": "https://api.github.com/repos/mralexgray/ace",
                    "forks_url": "https://api.github.com/repos/mralexgray/ace/forks",
                    "keys_url": "https://api.github.com/repos/mralexgray/ace/keys{/key_id}",
                    "collaborators_url": "https://api.github.com/repos/mralexgray/ace/collaborators{/collaborator}",
                    "teams_url": "https://api.github.com/repos/mralexgray/ace/teams",
                    "hooks_url": "https://api.github.com/repos/mralexgray/ace/hooks",
                    "issue_events_url": "https://api.github.com/repos/mralexgray/ace/issues/events{/number}",
                    "events_url": "https://api.github.com/repos/mralexgray/ace/events",
                    "assignees_url": "https://api.github.com/repos/mralexgray/ace/assignees{/user}",
                    "branches_url": "https://api.github.com/repos/mralexgray/ace/branches{/branch}",
                    "tags_url": "https://api.github.com/repos/mralexgray/ace/tags",
                    "blobs_url": "https://api.github.com/repos/mralexgray/ace/git/blobs{/sha}",
                    "git_tags_url": "https://api.github.com/repos/mralexgray/ace/git/tags{/sha}",
                    "git_refs_url": "https://api.github.com/repos/mralexgray/ace/git/refs{/sha}",
                    "trees_url": "https://api.github.com/repos/mralexgray/ace/git/trees{/sha}",
                    "statuses_url": "https://api.github.com/repos/mralexgray/ace/statuses/{sha}",
                    "languages_url": "https://api.github.com/repos/mralexgray/ace/languages",
                    "stargazers_url": "https://api.github.com/repos/mralexgray/ace/stargazers",
                    "contributors_url": "https://api.github.com/repos/mralexgray/ace/contributors",
                    "subscribers_url": "https://api.github.com/repos/mralexgray/ace/subscribers",
                    "subscription_url": "https://api.github.com/repos/mralexgray/ace/subscription",
                    "commits_url": "https://api.github.com/repos/mralexgray/ace/commits{/sha}",
                    "git_commits_url": "https://api.github.com/repos/mralexgray/ace/git/commits{/sha}",
                    "comments_url": "https://api.github.com/repos/mralexgray/ace/comments{/number}",
                    "issue_comment_url": "https://api.github.com/repos/mralexgray/ace/issues/comments/{number}",
                    "contents_url": "https://api.github.com/repos/mralexgray/ace/contents/{+path}",
                    "compare_url": "https://api.github.com/repos/mralexgray/ace/compare/{base}...{head}",
                    "merges_url": "https://api.github.com/repos/mralexgray/ace/merges",
                    "archive_url": "https://api.github.com/repos/mralexgray/ace/{archive_format}{/ref}",
                    "downloads_url": "https://api.github.com/repos/mralexgray/ace/downloads",
                    "issues_url": "https://api.github.com/repos/mralexgray/ace/issues{/number}",
                    "pulls_url": "https://api.github.com/repos/mralexgray/ace/pulls{/number}",
                    "milestones_url": "https://api.github.com/repos/mralexgray/ace/milestones{/number}",
                    "notifications_url": "https://api.github.com/repos/mralexgray/ace/notifications{?since,all,participating}",
                    "labels_url": "https://api.github.com/repos/mralexgray/ace/labels{/name}",
                    "releases_url": "https://api.github.com/repos/mralexgray/ace/releases{/id}",
                    "created_at": "2013-09-26T11:58:10Z",
                    "updated_at": "2013-10-26T12:34:49Z",
                    "pushed_at": "2013-10-26T12:34:48Z",
                    "git_url": "git://github.com/mralexgray/ace.git",
                    "ssh_url": "git@github.com:mralexgray/ace.git",
                    "clone_url": "https://github.com/mralexgray/ace.git",
                    "svn_url": "https://github.com/mralexgray/ace",
                    "homepage": "http://ace.c9.io",
                    "size": 21080,
                    "stargazers_count": 0,
                    "watchers_count": 0,
                    "language": "JavaScript",
                    "has_issues": false,
                    "has_downloads": true,
                    "has_wiki": true,
                    "forks_count": 0,
                    "mirror_url": null,
                    "open_issues_count": 0,
                    "forks": 0,
                    "open_issues": 0,
                    "watchers": 0,
                    "default_branch": "master",
                    "master_branch": "master"
                },
                {
                    "id": 10791045,
                    "name": "ACEView",
                    "full_name": "mralexgray/ACEView",
                    "owner": {
                        "login": "mralexgray",
                        "id": 262517,
                        "avatar_url": "https://gravatar.com/avatar/50e7ed4eb2e7af000ea7d161748958f1?d=https%3A%2F%2Fidenticons.github.com%2F27bbb5393e06a225e4ecf9c4ce6feabf.png&r=x",
                        "gravatar_id": "50e7ed4eb2e7af000ea7d161748958f1",
                        "url": "https://api.github.com/users/mralexgray",
                        "html_url": "https://github.com/mralexgray",
                        "followers_url": "https://api.github.com/users/mralexgray/followers",
                        "following_url": "https://api.github.com/users/mralexgray/following{/other_user}",
                        "gists_url": "https://api.github.com/users/mralexgray/gists{/gist_id}",
                        "starred_url": "https://api.github.com/users/mralexgray/starred{/owner}{/repo}",
                        "subscriptions_url": "https://api.github.com/users/mralexgray/subscriptions",
                        "organizations_url": "https://api.github.com/users/mralexgray/orgs",
                        "repos_url": "https://api.github.com/users/mralexgray/repos",
                        "events_url": "https://api.github.com/users/mralexgray/events{/privacy}",
                        "received_events_url": "https://api.github.com/users/mralexgray/received_events",
                        "type": "User",
                        "site_admin": false
                    },
                    "private": false,
                    "html_url": "https://github.com/mralexgray/ACEView",
                    "description": "Use the wonderful ACE editor in your Cocoa applications",
                    "fork": true,
                    "url": "https://api.github.com/repos/mralexgray/ACEView",
                    "forks_url": "https://api.github.com/repos/mralexgray/ACEView/forks",
                    "keys_url": "https://api.github.com/repos/mralexgray/ACEView/keys{/key_id}",
                    "collaborators_url": "https://api.github.com/repos/mralexgray/ACEView/collaborators{/collaborator}",
                    "teams_url": "https://api.github.com/repos/mralexgray/ACEView/teams",
                    "hooks_url": "https://api.github.com/repos/mralexgray/ACEView/hooks",
                    "issue_events_url": "https://api.github.com/repos/mralexgray/ACEView/issues/events{/number}",
                    "events_url": "https://api.github.com/repos/mralexgray/ACEView/events",
                    "assignees_url": "https://api.github.com/repos/mralexgray/ACEView/assignees{/user}",
                    "branches_url": "https://api.github.com/repos/mralexgray/ACEView/branches{/branch}",
                    "tags_url": "https://api.github.com/repos/mralexgray/ACEView/tags",
                    "blobs_url": "https://api.github.com/repos/mralexgray/ACEView/git/blobs{/sha}",
                    "git_tags_url": "https://api.github.com/repos/mralexgray/ACEView/git/tags{/sha}",
                    "git_refs_url": "https://api.github.com/repos/mralexgray/ACEView/git/refs{/sha}",
                    "trees_url": "https://api.github.com/repos/mralexgray/ACEView/git/trees{/sha}",
                    "statuses_url": "https://api.github.com/repos/mralexgray/ACEView/statuses/{sha}",
                    "languages_url": "https://api.github.com/repos/mralexgray/ACEView/languages",
                    "stargazers_url": "https://api.github.com/repos/mralexgray/ACEView/stargazers",
                    "contributors_url": "https://api.github.com/repos/mralexgray/ACEView/contributors",
                    "subscribers_url": "https://api.github.com/repos/mralexgray/ACEView/subscribers",
                    "subscription_url": "https://api.github.com/repos/mralexgray/ACEView/subscription",
                    "commits_url": "https://api.github.com/repos/mralexgray/ACEView/commits{/sha}",
                    "git_commits_url": "https://api.github.com/repos/mralexgray/ACEView/git/commits{/sha}",
                    "comments_url": "https://api.github.com/repos/mralexgray/ACEView/comments{/number}",
                    "issue_comment_url": "https://api.github.com/repos/mralexgray/ACEView/issues/comments/{number}",
                    "contents_url": "https://api.github.com/repos/mralexgray/ACEView/contents/{+path}",
                    "compare_url": "https://api.github.com/repos/mralexgray/ACEView/compare/{base}...{head}",
                    "merges_url": "https://api.github.com/repos/mralexgray/ACEView/merges",
                    "archive_url": "https://api.github.com/repos/mralexgray/ACEView/{archive_format}{/ref}",
                    "downloads_url": "https://api.github.com/repos/mralexgray/ACEView/downloads",
                    "issues_url": "https://api.github.com/repos/mralexgray/ACEView/issues{/number}",
                    "pulls_url": "https://api.github.com/repos/mralexgray/ACEView/pulls{/number}",
                    "milestones_url": "https://api.github.com/repos/mralexgray/ACEView/milestones{/number}",
                    "notifications_url": "https://api.github.com/repos/mralexgray/ACEView/notifications{?since,all,participating}",
                    "labels_url": "https://api.github.com/repos/mralexgray/ACEView/labels{/name}",
                    "releases_url": "https://api.github.com/repos/mralexgray/ACEView/releases{/id}",
                    "created_at": "2013-06-19T12:15:04Z",
                    "updated_at": "2013-10-30T12:39:24Z",
                    "pushed_at": "2013-10-30T12:39:18Z",
                    "git_url": "git://github.com/mralexgray/ACEView.git",
                    "ssh_url": "git@github.com:mralexgray/ACEView.git",
                    "clone_url": "https://github.com/mralexgray/ACEView.git",
                    "svn_url": "https://github.com/mralexgray/ACEView",
                    "homepage": null,
                    "size": 1661,
                    "stargazers_count": 0,
                    "watchers_count": 0,
                    "language": "Objective-C",
                    "has_issues": false,
                    "has_downloads": true,
                    "has_wiki": true,
                    "forks_count": 0,
                    "mirror_url": null,
                    "open_issues_count": 0,
                    "forks": 0,
                    "open_issues": 0,
                    "watchers": 0,
                    "default_branch": "master",
                    "master_branch": "master"
                }
            ]);
    });
});